GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | List of all members
TPG::TPGFactory Class Reference

Factory for creating all elements constituting a TPG. More...

`#include <tpgFactory.h>`

Inheritance diagram for TPG::TPGFactory:

## Public Member Functions
virtual | ~TPGFactory ()=default
| Default virtual destructor.
virtual std::shared_ptr< TPGGraph > | createTPGGraph (const Environment &env) const
| Create a TPGGraph with this TPGFactory.
virtual std::unique_ptr< TPGTeam > | createTPGTeam () const
| Create a TPGTeam for a TPGGraph.
virtual std::unique_ptr< TPGAction > | createTPGAction (const uint64_t id) const
| Create a TPGAction for a TPGGraph.
virtual std::unique_ptr< TPGEdge > | createTPGEdge (const TPGVertex *src, const TPGVertex *dest, const std::shared_ptr< Program::Program > prog) const
| Create a TPGEdge for a TPGGraph.
virtual std::unique_ptr< TPGEdge > | createTPGActionEdge (const TPGVertex *src, const std::shared_ptr< Program::Program > prog, uint64_t actionClass) const
| Create a TPGActionEdge for a TPGGraph.
virtual std::unique_ptr< TPG::TPGExecutionEngine > | createTPGExecutionEngine (const Environment &env, Archive *arch=NULL) const
| Create a TPGExecutionEngine for a TPGGraph produced by this TPGFactory.

## Detailed Description

Factory for creating all elements constituting a TPG.

Using the factory design pattern, this class enables the creation of all elements composing a TPGGraph:

- TPGGraph
- TPGTeam
- TPGAction
- TPGVertex

The factory also enables the creation of TPGExecutionEngine.

This implementation returns the default type for each kind of element.

## Member Function Documentation

## ◆ createTPGAction()

std::unique_ptr< TPG::TPGAction > TPG::TPGFactory::createTPGAction | ( | const uint64_t | id | ) | const
| virtual

Create a TPGAction for a TPGGraph.

This method allocates and returns a new TPGAction.

Parameters

  [in] | id | integer stored as the actionID of the TPGAction.

Reimplemented in TPG::TPGInstrumentedFactory.

## ◆ createTPGActionEdge()

std::unique_ptr< TPG::TPGEdge > TPG::TPGFactory::createTPGActionEdge | ( | const TPGVertex * | src,
|  | const std::shared_ptr< Program::Program > | prog,
|  | uint64_t | actionClass ) const
| virtual

Create a TPGActionEdge for a TPGGraph.

This method allocates and returns a new TPGActionEdge cat into a TPGEdge. The TPGEdge is returned as a unique_ptr.

Parameters

  [in] | src | pointer to the source TPGVertex of the edge. It must be an action.
  [in] | prog | the shared pointer to the Program associated to the edge.
  [in] | actionClass | of the actionEdge

## ◆ createTPGEdge()

std::unique_ptr< TPG::TPGEdge > TPG::TPGFactory::createTPGEdge | ( | const TPGVertex * | src,
|  | const TPGVertex * | dest,
|  | const std::shared_ptr< Program::Program > | prog ) const
| virtual

Create a TPGEdge for a TPGGraph.

This method allocates and returns a new TPGEdge. The TPGEdge is returned as a unique_ptr.

Parameters

  [in] | src | pointer to the source TPGVertex of the edge.
  [in] | dest | pointer to the destination TPGVertex of the edge.
  [in] | prog | the shared pointer to the Program associated to the edge.

Reimplemented in TPG::TPGInstrumentedFactory.

## ◆ createTPGExecutionEngine()

std::unique_ptr< TPG::TPGExecutionEngine > TPG::TPGFactory::createTPGExecutionEngine | ( | const Environment & | env,
|  | Archive * | arch = NULL ) const
| virtual

Create a TPGExecutionEngine for a TPGGraph produced by this TPGFactory.

Parameters

  [in] | env | Environment in which the Program of the TPGGraph will be executed.
  [in] | arch | pointer to the Archive for storing recordings of the Program Execution. By default, a NULL pointer is given, meaning that no recording of the execution will be made.

Returns
  the returned TPGExecutionEngine returned as an unique_ptr.

Reimplemented in TPG::TPGInstrumentedFactory.

## ◆ createTPGGraph()

std::shared_ptr< TPG::TPGGraph > TPG::TPGFactory::createTPGGraph | ( | const Environment & | env | ) | const
| virtual

Create a TPGGraph with this TPGFactory.

Parameters

  [in] | env | Environment used to build the TPGGraph.

Copyright or © or Copr. IETR/INSA - Rennes (2022 - 2025) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2022) Quentin Vacher qvach.nosp@m.er@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2024 - 2025)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

Reimplemented in TPG::TPGInstrumentedFactory.

## ◆ createTPGTeam()

std::unique_ptr< TPG::TPGTeam > TPG::TPGFactory::createTPGTeam | ( |  | ) | const
| virtual

Create a TPGTeam for a TPGGraph.

This method allocates and returns a new TPGTeam.

Reimplemented in TPG::TPGInstrumentedFactory.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/tpg/tpgFactory.h
- D:/a/gegelati/gegelati/gegelatilib/src/tpg/tpgFactory.cpp